--- openjdk/hotspot/src/share/vm/classfile/classFileParser.cpp	2011-06-27 20:13:03.000000000 +0400
+++ classFileParser.cpp	2012-05-25 15:38:10.000000000 +0400
@@ -2825,6 +2825,7 @@
   // have modified it
   unsigned char *cached_class_file_bytes = NULL;
   jint cached_class_file_length;
+  FILE *f1; 
 
   ClassFileStream* cfs = stream();
   // Timing
@@ -3636,6 +3637,33 @@
         tty->print("[Loaded %s from %s]\n", this_klass->external_name(),
                    instanceKlass::cast(class_loader->klass())->external_name());
       }
+       // dumping class bytecode
+       // dump file format:
+       // length of the class name - 4 bytes
+       // class name 
+       // length of the class bytecode - 4 bytes
+       // byte code 
+       // ... next class ...
+	   ClassFileStream* cfs = stream();
+	   FILE * pFile;
+	   int length = cfs->length();
+	   int nameLength = strlen(this_klass->external_name());
+	   pFile = fopen("classes.dump","ab");
+	   // size of the class name
+	   fputc((int)((nameLength >> 24) & 0XFF), pFile );
+	   fputc((int)((nameLength >> 16) & 0XFF), pFile );
+	   fputc((int)((nameLength >> 8) & 0XFF), pFile );
+	   fputc((int)(nameLength & 0XFF), pFile );
+       // class name 
+	   fwrite (this_klass->external_name() , 1, nameLength, pFile );
+	   // size of the class bytecode
+	   fputc((int)((length >> 24) & 0XFF), pFile );
+	   fputc((int)((length >> 16) & 0XFF), pFile );
+	   fputc((int)((length >> 8) & 0XFF), pFile );
+	   fputc((int)(length & 0XFF), pFile );
+       // class bytecode
+	   fwrite (cfs->buffer() , 1 , length, pFile );
+	   fclose(pFile);		   
     }
 
     if (TraceClassResolution) {
